package org.gcube.portlets.user.dataminermanagertester.server.testconfig;

import java.util.ArrayList;
***REMOVED***

import org.gcube.data.analysis.dataminermanagercl.shared.data.OutputData;
import org.gcube.data.analysis.dataminermanagercl.shared.data.output.MapResource;
import org.gcube.data.analysis.dataminermanagercl.shared.data.output.Resource;
import org.gcube.data.analysis.dataminermanagercl.shared.parameters.FileParameter;
import org.gcube.data.analysis.dataminermanagercl.shared.parameters.Parameter;
***REMOVED***
***REMOVED***
***REMOVED***

/**
 * 
 * @author Giancarlo Panichi
 *
 *
 */
public class WebAppPublisherTest implements DMTest {
	private static Logger logger = LoggerFactory.getLogger(WebAppPublisherTest.class);
	private static final String id = "org.gcube.dataanalysis.wps.statisticalmanager.synchserver.mappedclasses.transducerers.WEB_APP_PUBLISHER";

	@Override
	public String getId() {
		return id;
***REMOVED***

	@Override
	public void createRequest(Operator operator) {
		logger.debug("Create Request");

		FileParameter zipFile = new FileParameter();
		zipFile.setName("ZipFile");
		zipFile.setValue("https://data.d4science.org/ZXNmbldzUDh2cEJrMXBkVER6VzVEVWlSZzBScDJ2dVlHbWJQNStIS0N6Yz0");

		List<Parameter> parameters = new ArrayList<>();

		parameters.add(zipFile);

		logger.debug("Parameters set: " + parameters);
		operator.setOperatorParameters(parameters);

***REMOVED***

	@Override
	public String getResult(OutputData outputData) {
		StringBuilder result = new StringBuilder();
		logger.debug("Output: " + outputData);
		Resource resource = outputData.getResource();
		if (resource.isMap()) {
			MapResource mapResource = (MapResource) resource;
			for (String key : mapResource.getMap().keySet()) {
				logger.debug("Entry: " + key + " = " + mapResource.getMap().get(key));
				result.append("Entry: " + key + " = " + mapResource.getMap().get(key));
***REMOVED***

***REMOVED*** else {

***REMOVED***
		return result.toString();
***REMOVED***

	@Override
	public boolean isValidResult(OutputData outputData) {
		boolean valid;
		logger.debug("Output: " + outputData);
		Resource resource = outputData.getResource();
		if (resource.isMap()) {
			MapResource mapResource = (MapResource) resource;
			for (String key : mapResource.getMap().keySet()) {
				logger.debug("Entry: " + key + " = " + mapResource.getMap().get(key));
***REMOVED***
			valid = true;

***REMOVED*** else {
			valid = false;
***REMOVED***
		return valid;

***REMOVED***

***REMOVED***
